de.dhbwstuttgart.syntaxtree.type

## Class ExtendsWildcardType

- java.lang.Object
- - de.dhbwstuttgart.syntaxtree.SyntaxTreeNode
  - - de.dhbwstuttgart.syntaxtree.type.Type
    - - de.dhbwstuttgart.syntaxtree.type.WildcardType
      - - de.dhbwstuttgart.syntaxtree.type.ExtendsWildcardType

- All Implemented Interfaces:
    IItemWithOffset, IMatchable, ITypeContainer

      public class ExtendsWildcardType
      extends WildcardType
      implements ITypeContainer, IMatchable

  Stellt eine Wildcard mit oberer Grenze dar. z.B. void test(? extends Number var){..} ...
  Author:
    luar 2.12.06

- - ### Field Summary

    - ### Fields inherited from class de.dhbwstuttgart.syntaxtree.type.WildcardType

      `innerType`

    - ### Fields inherited from class de.dhbwstuttgart.syntaxtree.type.Type

      `name, used`

    - ### Fields inherited from class de.dhbwstuttgart.syntaxtree.SyntaxTreeNode

      `parent`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ExtendsWildcardType(int offset, ObjectType extendsType)` Author: Arne LÃ¼dtke Standard Konstruktor fÃ¼r eine ExtendsWildcard
    `ExtendsWildcardType(ObjectType extendsType)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ExtendsWildcardType` | `clone()` Author: Arne LÃ¼dtke Gibt einen Klon der Wildcard zurÃ¼ck.
    `boolean` | `equals(java.lang.Object obj)` Author: Arne LÃ¼dtke Vergleicht mit einem anderen Objekt.
    `ObjectType` | `get_ExtendsType()` Author: Arne LÃ¼dtke Gibt den Typen in der Wildcard zurÃ¼ck.
    `ObjectType` | `getContainedType()` Author: Arne LÃ¼dtke Das gleiche wie get_ExtendsType().
    `FreshExtendsWildcardType` | `GetFreshWildcardType()` Author: Arne LÃ¼dtke Gibt die passende FreshWildcardType Klasse zurÃ¼ck.
    `Menge<TypePlaceholder>` | `getInvolvedTypePlaceholder()` Sammelt alle TypePlaceholder, welche in diesem Typ vorkommen.
    `ObjectType` | `getMatchType()` Author: Arne LÃ¼dtke Gibt den Typen zurÃ¼ck, der bei einem match im Unify verwendet werden soll.
    `Type` | `GetWildcardType()` Author: Arne LÃ¼dtke Das gleiche wie get_ExtendsType().
    `void` | `parserPostProcessing(SyntaxTreeNode parent)` Wird nach dem Parsen aufgerufen.
    `JavaCodeResult` | `printJavaCode(ResultSet resultSet)`
    `void` | `SetWildcardType(ObjectType T)` Author: Arne LÃ¼dtke Setzt den Typ in der Wildcard
    `java.lang.String` | `toString()` Author: Arne LÃ¼dtke Gibt String Entsprechung zurÃ¼ck.
    `ConstraintType` | `TYPE(TypeAssumptions ass, SyntaxTreeNode parent)` PrÃ¼ft ob der Typ in den Assumptions ass vorhanden ist.

    - ### Methods inherited from class de.dhbwstuttgart.syntaxtree.type.WildcardType

      `SetWildcardType`

    - ### Methods inherited from class de.dhbwstuttgart.syntaxtree.type.Type

      `applyResultSet, checkTYPE, get_Name, get_UsedId, getChildren, getName, getOffset, getSimpleName, getSuperWildcardTypes, getUnresolvedTPH, getVariableLength, involves, set_UsedId, setOffset, Type2Key, Type2String`

    - ### Methods inherited from class de.dhbwstuttgart.syntaxtree.SyntaxTreeNode

      `addTypeInsertPoints, getDescription, getGTVDeclarationContext, getMatchingParentNode, getParent, getParentClass, seesType`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ExtendsWildcardType

          public ExtendsWildcardType(int offset,
                                     ObjectType extendsType)

      Author: Arne LÃ¼dtke
      Standard Konstruktor fÃ¼r eine ExtendsWildcard

    - #### ExtendsWildcardType

          public ExtendsWildcardType(ObjectType extendsType)

  - ### Method Detail

    - #### get_ExtendsType

          public ObjectType get_ExtendsType()

      Author: Arne LÃ¼dtke
      Gibt den Typen in der Wildcard zurÃ¼ck. Beispiel: ? extends Integer. Integer wird zurÃ¼ckgegeben.

    - #### toString

          public java.lang.String toString()

      Author: Arne LÃ¼dtke
      Gibt String Entsprechung zurÃ¼ck.
      Overrides:
        `toString` in class `WildcardType`

    - #### clone

          public ExtendsWildcardType clone()

      Author: Arne LÃ¼dtke
      Gibt einen Klon der Wildcard zurÃ¼ck. Der Innere Typ wird auch geklont
      Overrides:
        `clone` in class `WildcardType`
      Returns:
        // ino.end // ino.method.clone.26768.definition public Type clone() // ino.end // ino.method.clone.26768.body { return new RefType(this.getName().toString(), this.getParent(),getOffset()); } // ino.end

    - #### equals

          public boolean equals(java.lang.Object obj)

      Author: Arne LÃ¼dtke
      Vergleicht mit einem anderen Objekt.
      Overrides:
        `equals` in class `WildcardType`
      Parameters:
        `obj` - - Object to compare.

    - #### GetFreshWildcardType

          public FreshExtendsWildcardType GetFreshWildcardType()

      Author: Arne LÃ¼dtke
      Gibt die passende FreshWildcardType Klasse zurÃ¼ck. Wird fÃ¼r CaptureConversion verwendet
      Overrides:
        `GetFreshWildcardType` in class `WildcardType`

    - #### GetWildcardType

          public Type GetWildcardType()

      Author: Arne LÃ¼dtke
      Das gleiche wie get_ExtendsType(). Ãberschreibt die Methode der Superklasse.
      Overrides:
        `GetWildcardType` in class `WildcardType`

    - #### SetWildcardType

          public void SetWildcardType(ObjectType T)

      Author: Arne LÃ¼dtke
      Setzt den Typ in der Wildcard
      Parameters:
        `T` - - Type to be set

    - #### getContainedType

          public ObjectType getContainedType()

      Author: Arne LÃ¼dtke
      Das gleiche wie get_ExtendsType(). Implementiert ITypeContainer
      Specified by:
        `getContainedType` in interface `ITypeContainer`

    - #### getMatchType

          public ObjectType getMatchType()

      Author: Arne LÃ¼dtke
      Gibt den Typen zurÃ¼ck, der bei einem match im Unify verwendet werden soll. Wird Ã¼ber IMatchable implementiert.
      Specified by:
        `getMatchType` in interface `IMatchable`

    - #### printJavaCode

          public JavaCodeResult printJavaCode(ResultSet resultSet)

      Overrides:
        `printJavaCode` in class `WildcardType`

    - #### getInvolvedTypePlaceholder

          public Menge<TypePlaceholder> getInvolvedTypePlaceholder()

      Description copied from class: `Type`
      Sammelt alle TypePlaceholder, welche in diesem Typ vorkommen.
      Overrides:
        `getInvolvedTypePlaceholder` in class `Type`
      Returns:

    - #### parserPostProcessing

          public void parserPostProcessing(SyntaxTreeNode parent)

      Description copied from class: `SyntaxTreeNode`
      Wird nach dem Parsen aufgerufen. ErfÃ¼llt folgenden Aufgaben: 1. FÃ¼llt fehlende Typangaben mit TPHs auf. 2. VerknÃ¼pft die Knoten des Syntaxbaums. (setzt Parent) 3. Wechselt RefTypes gegebenenfalls mit GenericTypeVars aus. 4. FÃ¼hrt einen Teil des Syntaxckecks durch.
      Overrides:
        `parserPostProcessing` in class `SyntaxTreeNode`

    - #### TYPE

          public ConstraintType TYPE(TypeAssumptions ass,
                                     SyntaxTreeNode parent)

      Description copied from class: `Type`
      PrÃ¼ft ob der Typ in den Assumptions ass vorhanden ist. Dabei kann eine neue Instanz eines Typs entstehen, welche von der Methode zurÃ¼ckgegeben wird.
      Overrides:
        `TYPE` in class `WildcardType`
      Parameters:
        `ass` - - Die Assumptions fÃ¼r den jeweiligen Kontext in dem sich der Typ befindet. public ConstraintType checkType(TypeAssumptions ass, SyntaxTreeNode parent){ ConstraintType t = ass.getTypeFor(this, this); if(t==null) throw new TypeinferenceException("Der Typ "+this.getName()+" ist nicht korrekt", parent); return t; }